package it.eng.components.cimero;


import org.spagic.utils.SpagicLogger;

import com.bull.cimero.pluginEditor.editors.model.SEModel.ServiceEngineModel;

/**
 * @author Andrea Zoppello
 */
public class AttachmentSplitter extends ServiceEngineModel {

	/** Serial UID. */
	private static final long serialVersionUID = 1L;
	/** Default name. */
	private static final String DEFAULTNAME = "myAttachmentSplitter";
	/**the id of this element.*/
	private static final String ID = "SYNC";
	
	/**The name of the destination service property.*/
	private static final String NAMEDEST = "destination service";
	

	/**
	 * default constructor.
	 */
	public AttachmentSplitter() {
		super(DEFAULTNAME, 1, DEFAULTOUTIN);
		//set the properties
		setProperty(NAME, DEFAULTNAME);
		
		setProperty(NAMEDEST, "");

	}
	
	public void configureCustomComponent(){
		
		
	}


	

	/**
	 * The validate function. It is used to determine if the instance class
	 * is valide or not.
	 * @param showLog : true if the log must to be show.
	 * @return boolean
	 */
	@Override
	public final boolean isValide(final boolean showLog) {
		String msg = "";
		boolean returnResult = true;
		//name verification
		if (getName().compareTo("") == 0) {
			msg += "\n1 - Name => the sync name cannot be null";
			returnResult = false;
		}
		
		if (getNameFirstDestination().compareTo("") == 0) {
			msg += "\n4 - Destination service => the destination of this "
						+ "element cannot be null!";
			returnResult = false;
		}
		if (!returnResult) {
			msg = msg.substring(1);
			msg = "ELEMENT NAME : " + getName() + "\n" + msg;
			if (showLog) {
				SpagicLogger.warning(msg);
			}
		}
		return returnResult;
	}

	/**
	 * Abstract method of GeneriqueCimeroModel. It is used to
	 * create the descriptor
	 */
	@Override
	protected final void createDescriptor() {
		int indice = 1;
		addTextDescriptor(NAME, indice++ + " - name");
		//addTextDescriptor(LOCATIONURI, indice++
		//		+ " - select the location URI of the WS");
		//addComboBoxDescriptor(SOAPREQUEST, indice++ + " - soap request ? :",
		//				new String[]{"true", "false"});
		String [] lstStr = getLstObjectDrawWithInputConnection();
		addComboBoxDescriptor(NAMEDEST, indice++
				+ " - select the destination service", lstStr);

	}

	/**
	 * return the id of this element.
	 * @return the id of this element.
	 */
	@Override
	public final String getComponentId() {
		return ID;
	}

	/**
	 * IPropertySource abstract method.
	 * @return Object
	 * @param id : the id of the property
	 */
	public final Object getPropertyValue(final Object id) {
		if (NAMEDEST.equals(id)) {
			//we retreive the name of the destination object
			String destinationName = getNameFirstDestination();
			//return the num of the name  of the object
			String [] lstStr = getLstObjectDrawWithInputConnection();
			for (int i = 0; i < lstStr.length; i++) {
				if (lstStr[i].compareTo(destinationName) == 0) {
					return i;
				}
			}
			return 0;
		} else {
			return super.getPropertyValue(id);
		}
	}

	/**
	 * IPropertySource abstract method.
	 * @param value : the value of the property
	 * @param id : the id of the property
	 */
	public final void setPropertyValue(final Object id, final Object value) {
		if (id == NAMEDEST) {
			//we retreive the destination name
			int selecNum = Integer.parseInt(value.toString());
			//retreive the list af all the objects name
			String [] lstStr = getLstObjectDrawWithInputConnection();
			//call the function to create a connection beetween
			//this object and the selected object
			if (!refreshDestinationConnection(lstStr[selecNum])) {
				SpagicLogger.error("problem when created connection",
						new Exception());
			}
		}
		super.setPropertyValue(id, value);
	}

	/**
	 * IPropertySource abstract method.
	 * @param id : the id of the property
	 */
	public final void resetPropertyValue(final Object id) {
	}

}
