package it.eng.utils;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.spagic.bpmn.conversion.Spagic1ToSpagic2Activator;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


import com.bull.cimero.pluginEditor.utils.ressources.Ressources;

/**
 * Helper class that provide information about configured Datasources
 * It <strong>read</strong> info about SpagicStudio configured ones. 
 * 
 * Maintain datasources available by read position and by name.
 * 
 * @author buso
 *
 */
public class DataSourceGuiHelper implements Serializable {
	
	/**
	 * Contain <strong>Datasources.xml</strong> ids as key and the read position as value.
	 * These ids are aliases for datasource configurations.
	 */
	private Map<String, Integer> dataSourceIds = null;
	/**
	 * Contain <strong>Datasources.xml</strong> read position as key and ids as value.
	 */
	private Map<Integer,String > dataSourcePositions = null;
	private String defaultDatasourceName = "";

	public DataSourceGuiHelper() {
		init();
	}
	
	public void init() {
		this.dataSourceIds = new HashMap<String, Integer>();
		this.dataSourcePositions = new HashMap<Integer, String>();

		dataSourceIds.put("metadb", 0);
		defaultDatasourceName = "metadb";
		dataSourcePositions.put(0, "metadb");
	}
	
	public String getDefaultDatasourceName() {
		return defaultDatasourceName;
	}
	
	public String getIdByPosition(Object position) {
		return dataSourcePositions.get(position);
	}
	
	public Integer getPositionById(Object dsId) {
		return dataSourceIds.get(dsId);
	}
	
	public String[] getIdNames() {
		Set<String> keys = dataSourceIds.keySet(); 
		return keys.toArray(new String[keys.size()]);
	}
}
