package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIAdvancedJMS implements JET2Template {

    public _jet_JBIAdvancedJMS() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String role = "consumer";
   	if (bindingName.equalsIgnoreCase("JBI-JMSAdvancedOutputBindingComponent")){
   		role = "provider";
   	}
   	
   	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
   	
   	String mep = null;
   	mep = JBIJetUtils.MEP_IN_ONLY;
   	if (bindingName.equalsIgnoreCase("JBI-JMSInputOutputBindingComponent")){
   		mep = JBIJetUtils.MEP_IN_OUT;
   	} 
   	
   	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	if (flagTransformerPipeline){
		role = "provider";
	}
   	
   
   	String soap = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSoap", "false");   	
   	boolean flagIsSoap = Boolean.valueOf(soap);
   	
   	String useJndiContextFromJbiContainer = JBIJetUtils.getRequiredPropertyValue(aStep, "UseJndiContextFromJbiContainer"); 
	boolean flagUseJndiContextFromJbiContainer = Boolean.valueOf(useJndiContextFromJbiContainer);
	
	String destinationType = JBIJetUtils.getRequiredPropertyValue(aStep, "JmsDestinationType");
	String endpointType = (flagIsSoap ? "soap-" : "") + role;

        out.write(NL);         
	if (!flagUseJndiContextFromJbiContainer) {
        out.write("\t<bean id=\"connectionFactory\" class=\"org.springframework.jndi.JndiObjectFactoryBean\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    <property name=\"jndiName\" value=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JmsConnectionFactoryName"));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    <property name=\"jndiEnvironment\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t        <props>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t            <prop key=\"java.naming.factory.initial\">");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "InitialContextFactory"));
        out.write("</prop>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t            <prop key=\"java.naming.provider.url\">");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JndiProviderUrl"));
        out.write("</prop>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t        </props>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    </property>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
	} else { 
        out.write("\t<bean id=\"connectionFactory\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\tclass=\"org.springframework.jndi.JndiObjectFactoryBean\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<property name=\"jndiName\" value=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JmsConnectionFactoryName"));
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
	} 
        out.write(NL);         
        out.write("<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tpubSubDomain=\"");  //$NON-NLS-1$        
        out.write("topic".equals(destinationType)?"true":"false");
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
      if ("consumer".equals(role)) {
        out.write("\t\t\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\ttargetEndpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tconcurrentConsumers=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConcurrentConsumers"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\ttransacted=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "TransactionType"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write("\t\tdestinationName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JmsProviderDestinationName"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\tconnectionFactory=\"#connectionFactory\"");  //$NON-NLS-1$        
        out.write(NL);         
      if ("consumer".equals(role)) {
			boolean isUseMsgIdInResponse=Boolean.valueOf(JBIJetUtils.getOptionalPropertyValue(aStep, "UseJmsMessageId", "false"));
			if (isUseMsgIdInResponse){	

        out.write("\t\t\t\tuseMessageIdInResponse=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         

			}		
		}

        out.write(">\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
