package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIQuartzTimer implements JET2Template {

    public _jet_JBIQuartzTimer() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String triggerType = JBIJetUtils.getRequiredPropertyValue(aStep, "TriggerType");
	

        out.write(NL);         
        out.write("\t<quartz:endpoint ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<quartz:trigger>");  //$NON-NLS-1$        
        out.write(NL);         
 if (triggerType.equalsIgnoreCase("cron")) { 
        out.write("  \t\t\t  <quartz:cron cronExpression=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "CronExpression"));
        out.write("\" /> ");  //$NON-NLS-1$        
        out.write(NL);         
 } else {
        out.write(" \t\t\t <quartz:simple repeatCount=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RepeatCount"));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(" \t\t\t \t\t\t\trepeatInterval=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RepeatInterval"));
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
 } 
        out.write("  \t\t\t</quartz:trigger>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t</quartz:endpoint>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
    }
}
