package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardHTTP implements JET2Template {
    private static final String _jetns_ws = "org.eclipse.jet.workspaceTags"; //$NON-NLS-1$

    public _jet_JBIStandardHTTP() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_ws_copyFile_231_2 = new TagInfo("ws:copyFile", //$NON-NLS-1$
            231, 2,
            new String[] {
                "src", //$NON-NLS-1$
                "srcContext", //$NON-NLS-1$
                "target", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/{$relativeFileNameToProject}", //$NON-NLS-1$
                "workspace", //$NON-NLS-1$
                "{$relativeFileNameToServiceUnit}", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String role = "consumer";
   	if (bindingName.equalsIgnoreCase("JBI-HTTPOutputBindingComponent")){
   		role = "provider";
   	}
   	
   	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
   	
	
		
   	String mep = null;
   	
   	if (bindingName.equalsIgnoreCase("JBI-HTTPInputBindingComponent") || bindingName.equalsIgnoreCase("WebserviceEventBindingComponent")){
   		mep = JBIJetUtils.MEP_IN_ONLY;
   	} else {
   		mep = JBIJetUtils.MEP_IN_OUT;
   	}
   	
   	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	if (flagTransformerPipeline){
		role = "provider";
	}
   	
   	String locationURI = JBIJetUtils.getRequiredPropertyValue(aStep, "Uri");
   	String soap = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSoap", "true");
   	String soapVersion = JBIJetUtils.getOptionalPropertyValue(aStep, "SoapVersion", "");
   	String soapAction = JBIJetUtils.getOptionalPropertyValue(aStep, "SoapAction", "");
   	String wsdlFile = JBIJetUtils.getOptionalPropertyValue(aStep, "WsdlFile", null);
   	
   	String isSslEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSslEnabled", "false");
	Boolean isSslEnabled = Boolean.valueOf(isSslEnabledString);
	
	String clientAuthentication = JBIJetUtils.getOptionalPropertyValue(aStep, "ClientAuthentication", "NoAuthentication");
	boolean  isClientAuthenticationEnabled = clientAuthentication.equalsIgnoreCase("OptionalClientAuthentication") || clientAuthentication.equalsIgnoreCase("MandatoryClientAuthentication");
	
   	String isProxyEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsProxyEnabled", "false");
	Boolean isProxyEnabled = Boolean.valueOf(isProxyEnabledString);

	String isHTTPCompressionEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagHTTPCompressionEnabled", "false");
	Boolean isHTTPCompressionEnabled = Boolean.valueOf(isHTTPCompressionEnabledString);

	String isHTTPCompressRequestString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagHTTPCompressRequest", "false");
	Boolean isHTTPCompressRequest = Boolean.valueOf(isHTTPCompressRequestString);
	
	// WSDL Is not specify as property 
	if (wsdlFile == null) {
		String projectName = (String)context.getVariable("org.eclipse.jet.resource.project.name");
		wsdlFile = "WsdlFiles/"+SpagicUtils.getStepLocalNamePart(aProcess, aStep) + ".wsdl";
		boolean existWsdlFile = JBIJetUtils.existFileInProject(projectName, wsdlFile);
		if (!existWsdlFile){
			System.out.println(" wsdlFile [" +wsdlFile +"] do not exist ");
			wsdlFile = null;
		}
	}
	

        out.write(NL);         
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":endpoint");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tdefaultMep=\"");  //$NON-NLS-1$        
        out.write(mep);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
      if ("provider".equals(role)) {
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}else{
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write("\t\t\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\trole=\"");  //$NON-NLS-1$        
        out.write(role);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tlocationURI=\"");  //$NON-NLS-1$        
        out.write(locationURI);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoap=\"");  //$NON-NLS-1$        
        out.write(soap);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoapVersion=\"");  //$NON-NLS-1$        
        out.write(soapVersion);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoapAction=\"");  //$NON-NLS-1$        
        out.write(soapAction);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
      if (isHTTPCompressionEnabled) {	
        out.write("\t\t\t\t\tgzipCompressionEnabled=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
		}								
     	if (isHTTPCompressRequest) {	
        out.write("\t\t\t\t\tgzipRequest=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
		}								

					if (wsdlFile != null){
						String wsdlresourceString = "classpath:"+JBIJetUtils.getRelativeFileName(wsdlFile);
					   	

        out.write("\t\t\t\t\t   wsdlResource=\"");  //$NON-NLS-1$        
        out.write(wsdlresourceString);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t   ");  //$NON-NLS-1$        
        out.write(NL);         
 					}
        out.write("\t\t\t\t\t>");  //$NON-NLS-1$        
        out.write(NL);         
 if (isSslEnabled) {
						String keyStoreR = null;
						String keyStorePass = null;
						String keyStoreType = null;
						String trustStoreR = null;
						String trustStorePass = null;
						String trustStoreType = null;
							
						String keyStorePar = JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStore", null);
						if (keyStorePar != null){
							keyStoreR = "classpath:"+  keyStorePar;
							keyStorePass = JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStorePassword", null);
							keyStoreType = JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStoreType", null);
						}
						
						String trustStorePar = JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStore", null);
						if (trustStorePar != null){
							trustStoreR = "resources/keystores/"+trustStorePar;
							trustStorePass = JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStorePassword",null);
							trustStoreType = JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStoreType", null);
							
						}
						
						
						
					
        out.write("\t\t\t\t\t\t<http:ssl>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t<http:sslParameters ");  //$NON-NLS-1$        
        out.write(NL);         
if (keyStoreR != null){
        out.write("    \t\t\t\t\t\t     ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t     \tkeyStore=\"");  //$NON-NLS-1$        
        out.write(keyStoreR);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t     ");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("    \t\t\t\t\t\t     ");  //$NON-NLS-1$        
        out.write(NL);         
if (keyStorePass != null){
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t \tkeyStorePassword=\"");  //$NON-NLS-1$        
        out.write(keyStorePass);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
if (keyStoreType != null){
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t \tkeyStoreType=\"");  //$NON-NLS-1$        
        out.write(keyStoreType);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
if (trustStoreR != null){
        out.write("    \t\t\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t \ttrustStore=\"");  //$NON-NLS-1$        
        out.write(trustStoreR);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
}
if (trustStoreType != null){
        out.write("    \t\t\t\t\t\t\t  ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t \ttrustStoreType=\"");  //$NON-NLS-1$        
        out.write(trustStoreType);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t \t");  //$NON-NLS-1$        
        out.write(NL);         
}
if (trustStorePass != null){
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t \ttrustStorePassword=\"");  //$NON-NLS-1$        
        out.write(trustStorePass);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("    \t\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
 if (role.equalsIgnoreCase("consumer")) { 
    								if (clientAuthentication.equalsIgnoreCase("OptionalClientAuthentication")){
        out.write("    \t\t\t\t\t\t\t\t\twantClientAuth=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t\t\tneedClientAuth=\"false\"");  //$NON-NLS-1$        
        out.write(NL);         
 }else if (clientAuthentication.equalsIgnoreCase("MandatoryClientAuthentication")){ 
        out.write("    \t\t\t\t\t\t\t\t\twantClientAuth=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t\t\tneedClientAuth=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
 } else { 
        out.write("    \t\t\t\t\t\t\t\t\twantClientAuth=\"false\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t\t\tneedClientAuth=\"false\"");  //$NON-NLS-1$        
        out.write(NL);         
 }	 
    						 } 
        out.write("    \t\t\t\t\t\t/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t\t\t\t\t</http:ssl>");  //$NON-NLS-1$        
        out.write(NL);         
 } 
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
 if (isProxyEnabled) { 
					   	String proxyHost = JBIJetUtils.getRequiredPropertyValue(aStep, "ProxyHost");
					   	String proxyPort = JBIJetUtils.getRequiredPropertyValue(aStep, "ProxyPort");
					
					   	String isProxyAuthenticationRequiredString = JBIJetUtils.getRequiredPropertyValue(aStep, "FlagIsProxyAuthenticationRequired");
						Boolean isProxyAuthenticationRequired = Boolean.valueOf(isProxyAuthenticationRequiredString);
					
        out.write("\t\t\t\t\t\t<http:proxy>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t\t<http:proxyParameters proxyHost=\"");  //$NON-NLS-1$        
        out.write(proxyHost);
        out.write("\" proxyPort=\"");  //$NON-NLS-1$        
        out.write(proxyPort);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
 if (isProxyAuthenticationRequired) { 
							   	String proxyUsername = JBIJetUtils.getRequiredPropertyValue(aStep, "ProxyUsername");
							   	String proxyPassword = JBIJetUtils.getRequiredPropertyValue(aStep, "ProxyPassword");
							
        out.write("\t\t\t\t\t\t\t\t<http:proxyCredentials>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t\t\t\t\t<http:basicAuthCredentials username=\"");  //$NON-NLS-1$        
        out.write(proxyUsername);
        out.write("\" password=\"");  //$NON-NLS-1$        
        out.write(proxyPassword);
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t\t\t\t</http:proxyCredentials>");  //$NON-NLS-1$        
        out.write(NL);         
 } 
        out.write("\t\t\t\t\t\t\t</http:proxyParameters>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t</http:proxy>");  //$NON-NLS-1$        
        out.write(NL);         
 } 
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":endpoint>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
	if (wsdlFile != null) {
	context.setVariable("relativeFileNameToProject", wsdlFile);
	context.setVariable("relativeFileNameToServiceUnit", JBIJetUtils.getRelativeFileName(wsdlFile));
	

        out.write("\t");  //$NON-NLS-1$        
        RuntimeTagElement _jettag_ws_copyFile_231_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "copyFile", "ws:copyFile", _td_ws_copyFile_231_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_copyFile_231_2.setRuntimeParent(null);
        _jettag_ws_copyFile_231_2.setTagInfo(_td_ws_copyFile_231_2);
        _jettag_ws_copyFile_231_2.doStart(context, out);
        _jettag_ws_copyFile_231_2.doEnd();
        out.write(NL);         
 } 
    }
}
