package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import org.eclipse.stp.im.constants.*;
import org.eclipse.emf.common.util.EMap;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_main implements JET2Template {
    private static final String _jetns_ws = "org.eclipse.jet.workspaceTags"; //$NON-NLS-1$

    public _jet_main() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_ws_folder_75_2 = new TagInfo("ws:folder", //$NON-NLS-1$
            75, 2,
            new String[] {
                "path", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/Deployables", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_file_76_3 = new TagInfo("ws:file", //$NON-NLS-1$
            76, 3,
            new String[] {
                "template", //$NON-NLS-1$
                "path", //$NON-NLS-1$
            },
            new String[] {
                "templates/deploy.jet", //$NON-NLS-1$
                "{$deployFileName}.deploy", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_folder_98_2 = new TagInfo("ws:folder", //$NON-NLS-1$
            98, 2,
            new String[] {
                "path", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/Deployables", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_file_102_4 = new TagInfo("ws:file", //$NON-NLS-1$
            102, 4,
            new String[] {
                "template", //$NON-NLS-1$
                "path", //$NON-NLS-1$
            },
            new String[] {
                "templates/properties.jet", //$NON-NLS-1$
                "{$processName}.properties", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_folder_108_2 = new TagInfo("ws:folder", //$NON-NLS-1$
            108, 2,
            new String[] {
                "path", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/Deployables/{$saName}", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_folder_110_3 = new TagInfo("ws:folder", //$NON-NLS-1$
            110, 3,
            new String[] {
                "path", //$NON-NLS-1$
            },
            new String[] {
                "META-INF", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_file_111_7 = new TagInfo("ws:file", //$NON-NLS-1$
            111, 7,
            new String[] {
                "template", //$NON-NLS-1$
                "path", //$NON-NLS-1$
            },
            new String[] {
                "templates/jbixml.jet", //$NON-NLS-1$
                "jbi.xml", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_folder_120_4 = new TagInfo("ws:folder", //$NON-NLS-1$
            120, 4,
            new String[] {
                "path", //$NON-NLS-1$
            },
            new String[] {
                "{$suNameForProcess}", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_file_123_5 = new TagInfo("ws:file", //$NON-NLS-1$
            123, 5,
            new String[] {
                "template", //$NON-NLS-1$
                "path", //$NON-NLS-1$
            },
            new String[] {
                "templates/stdsu.jet", //$NON-NLS-1$
                "xbean.xml", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_file_127_5 = new TagInfo("ws:file", //$NON-NLS-1$
            127, 5,
            new String[] {
                "template", //$NON-NLS-1$
                "path", //$NON-NLS-1$
            },
            new String[] {
                "templates/lwsu.jet", //$NON-NLS-1$
                "servicemix.xml", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
 	
	System.out.println(" Entering in main.jet");
	
	JBIJetUtils.initJbiConfiguration();
	
	Resource res = (Resource)context.getSource();
	StpIntermediateModel stpModel = (StpIntermediateModel)res.getContents().get(0);
		
	JBIJetUtils.jbiIntermediateModelPreprocessor(stpModel);
	context.setVariable("stpModel", stpModel);
	
	List<org.eclipse.stp.im.Process> processesList = stpModel.getProcessCollection().getProcesses();
	
	// Compute the name of the deploy file
	String deployFileName = null;
	if (processesList.size() == 1) {
		// Only one process in the IM: use the process name
		org.eclipse.stp.im.Process aProcess = processesList.get(0);
		deployFileName = aProcess.getName() + "_v_" + SpagicUtils.getProcessVersion(aProcess);
	} else {
		// Use iter name and version, if available
		EMap<String, Property> imProperties = stpModel.getProperties();
		
		// Retrieve iter informations
		Property iterNameProperty = imProperties.get(ImConstants.IM_ITER_NAME);
		if (iterNameProperty != null) {
			deployFileName = (String)iterNameProperty.getValue();
			
			Property iterVersionProperty = imProperties.get(ImConstants.ITER_VERSION);
			if (iterVersionProperty != null) {
				deployFileName += "_v_" + (String)iterVersionProperty.getValue();
			} else {
				deployFileName += "_v_" + "0";
			}
		}
	}
	if (deployFileName == null) {
		deployFileName = res.getURI().lastSegment().replace("." + res.getURI().fileExtension(), "");
	}
	context.setVariable("deployFileName", deployFileName);

        out.write(NL);         
        RuntimeTagElement _jettag_ws_folder_75_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "folder", "ws:folder", _td_ws_folder_75_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_folder_75_2.setRuntimeParent(null);
        _jettag_ws_folder_75_2.setTagInfo(_td_ws_folder_75_2);
        _jettag_ws_folder_75_2.doStart(context, out);
        while (_jettag_ws_folder_75_2.okToProcessBody()) {
            out.write("\t\t");  //$NON-NLS-1$        
            RuntimeTagElement _jettag_ws_file_76_3 = context.getTagFactory().createRuntimeTag(_jetns_ws, "file", "ws:file", _td_ws_file_76_3); //$NON-NLS-1$ //$NON-NLS-2$
            _jettag_ws_file_76_3.setRuntimeParent(_jettag_ws_folder_75_2);
            _jettag_ws_file_76_3.setTagInfo(_td_ws_file_76_3);
            _jettag_ws_file_76_3.doStart(context, out);
            _jettag_ws_file_76_3.doEnd();
            out.write(NL);         
            _jettag_ws_folder_75_2.handleBodyContent(out);
        }
        _jettag_ws_folder_75_2.doEnd();
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
	
	for ( org.eclipse.stp.im.Process aProcess : processesList){
	
	if (SpagicUtils.isProcessDeployableForRuntime(
		aProcess, JBIJetUtils.getRuntimeId())){

	context.setVariable("process", aProcess);
	context.setVariable("processVersion", SpagicUtils.getProcessVersion(aProcess));
	context.setVariable("processName", aProcess.getName()+ "_v_" + SpagicUtils.getProcessVersion(aProcess));
	context.setVariable("saName", context.getVariable("processName")+"-sa");
	
	Map<String, List<Step>> processServiceUnitsMap = JBIJetUtils.getServiceUnitListForProcessModels(aProcess);
	Set<String> sus = processServiceUnitsMap.keySet();
	
	context.setVariable("processServiceUnitsMap", processServiceUnitsMap);
	
	JBIJetUtils.addFolder("Deployables/" + ((String)context.getVariable("saName")));


        RuntimeTagElement _jettag_ws_folder_98_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "folder", "ws:folder", _td_ws_folder_98_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_folder_98_2.setRuntimeParent(null);
        _jettag_ws_folder_98_2.setTagInfo(_td_ws_folder_98_2);
        _jettag_ws_folder_98_2.doStart(context, out);
        while (_jettag_ws_folder_98_2.okToProcessBody()) {
    	
    		if (SpagicUtils.isDeployableConfigurable(aProcess)) {
    
            out.write("\t\t\t");  //$NON-NLS-1$        
            RuntimeTagElement _jettag_ws_file_102_4 = context.getTagFactory().createRuntimeTag(_jetns_ws, "file", "ws:file", _td_ws_file_102_4); //$NON-NLS-1$ //$NON-NLS-2$
            _jettag_ws_file_102_4.setRuntimeParent(_jettag_ws_folder_98_2);
            _jettag_ws_file_102_4.setTagInfo(_td_ws_file_102_4);
            _jettag_ws_file_102_4.doStart(context, out);
            _jettag_ws_file_102_4.doEnd();
            out.write(NL);         
    	
    		}
    
            _jettag_ws_folder_98_2.handleBodyContent(out);
        }
        _jettag_ws_folder_98_2.doEnd();
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        RuntimeTagElement _jettag_ws_folder_108_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "folder", "ws:folder", _td_ws_folder_108_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_folder_108_2.setRuntimeParent(null);
        _jettag_ws_folder_108_2.setTagInfo(_td_ws_folder_108_2);
        _jettag_ws_folder_108_2.doStart(context, out);
        while (_jettag_ws_folder_108_2.okToProcessBody()) {
            out.write(NL);         
            RuntimeTagElement _jettag_ws_folder_110_3 = context.getTagFactory().createRuntimeTag(_jetns_ws, "folder", "ws:folder", _td_ws_folder_110_3); //$NON-NLS-1$ //$NON-NLS-2$
            _jettag_ws_folder_110_3.setRuntimeParent(_jettag_ws_folder_108_2);
            _jettag_ws_folder_110_3.setTagInfo(_td_ws_folder_110_3);
            _jettag_ws_folder_110_3.doStart(context, out);
            while (_jettag_ws_folder_110_3.okToProcessBody()) {
                out.write("   \t\t\t");  //$NON-NLS-1$        
                RuntimeTagElement _jettag_ws_file_111_7 = context.getTagFactory().createRuntimeTag(_jetns_ws, "file", "ws:file", _td_ws_file_111_7); //$NON-NLS-1$ //$NON-NLS-2$
                _jettag_ws_file_111_7.setRuntimeParent(_jettag_ws_folder_110_3);
                _jettag_ws_file_111_7.setTagInfo(_td_ws_file_111_7);
                _jettag_ws_file_111_7.doStart(context, out);
                _jettag_ws_file_111_7.doEnd();
                out.write(NL);         
                _jettag_ws_folder_110_3.handleBodyContent(out);
            }
            _jettag_ws_folder_110_3.doEnd();
    	
    		String suNameForProcess = null;
       		for ( String su : sus ){
       			suNameForProcess = aProcess.getName()+ "_v_" + SpagicUtils.getProcessVersion(aProcess) + "-" + JBIJetUtils.getServiceUnitBriefName(su);
       			context.setVariable("suNameForProcess", suNameForProcess);
       			context.setVariable("su", su);
    
            RuntimeTagElement _jettag_ws_folder_120_4 = context.getTagFactory().createRuntimeTag(_jetns_ws, "folder", "ws:folder", _td_ws_folder_120_4); //$NON-NLS-1$ //$NON-NLS-2$
            _jettag_ws_folder_120_4.setRuntimeParent(_jettag_ws_folder_108_2);
            _jettag_ws_folder_120_4.setTagInfo(_td_ws_folder_120_4);
            _jettag_ws_folder_120_4.doStart(context, out);
            while (_jettag_ws_folder_120_4.okToProcessBody()) {
                  if (JBIJetUtils.isStandard(su)){
        
                out.write("\t\t\t\t");  //$NON-NLS-1$        
                RuntimeTagElement _jettag_ws_file_123_5 = context.getTagFactory().createRuntimeTag(_jetns_ws, "file", "ws:file", _td_ws_file_123_5); //$NON-NLS-1$ //$NON-NLS-2$
                _jettag_ws_file_123_5.setRuntimeParent(_jettag_ws_folder_120_4);
                _jettag_ws_file_123_5.setTagInfo(_td_ws_file_123_5);
                _jettag_ws_file_123_5.doStart(context, out);
                _jettag_ws_file_123_5.doEnd();
                out.write(NL);         
        
        			}else{
        
                out.write("\t\t\t\t");  //$NON-NLS-1$        
                RuntimeTagElement _jettag_ws_file_127_5 = context.getTagFactory().createRuntimeTag(_jetns_ws, "file", "ws:file", _td_ws_file_127_5); //$NON-NLS-1$ //$NON-NLS-2$
                _jettag_ws_file_127_5.setRuntimeParent(_jettag_ws_folder_120_4);
                _jettag_ws_file_127_5.setTagInfo(_td_ws_file_127_5);
                _jettag_ws_file_127_5.doStart(context, out);
                _jettag_ws_file_127_5.doEnd();
                out.write(NL);         
        
        			} // END ELSE 
        
                _jettag_ws_folder_120_4.handleBodyContent(out);
            }
            _jettag_ws_folder_120_4.doEnd();
       		
       		}//	END LOOP ON SUS
    
            _jettag_ws_folder_108_2.handleBodyContent(out);
        }
        _jettag_ws_folder_108_2.doEnd();
}
}
        out.write(NL);         
        out.write(NL);         
    }
}
