package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_stdsu implements JET2Template {
    private static final String _jetns_c = "org.eclipse.jet.controlTags"; //$NON-NLS-1$

    public _jet_stdsu() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_c_include_68_4 = new TagInfo("c:include", //$NON-NLS-1$
            68, 4,
            new String[] {
                "template", //$NON-NLS-1$
            },
            new String[] {
                "{$templateName}", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    
  
	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)(context.getVariable("process"));
	String su = (String)context.getVariable("su");
	String suNameSpacePrefix = JBIJetUtils.getServiceUnitNameSpacePrefix(su);
	String suNameSpaceURI =  JBIJetUtils.getServiceUnitNameSpaceURI(su);
	context.setVariable("suNameSpacePrefix", suNameSpacePrefix);
	Map<String, List<Step>> processServiceUnitsMap = (Map<String, List<Step>>)context.getVariable("processServiceUnitsMap");
	
	List<Step> stepsForSU = (List<Step>)processServiceUnitsMap.get(su);
	

        out.write("<?xml version=\"1.0\"?>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<beans xmlns:");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRuntimeNameSpacePrefix());
        out.write("=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRuntimeNameSpaceURI());
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   xmlns:");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write("=\"");  //$NON-NLS-1$        
        out.write(suNameSpaceURI);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   xmlns:");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getNamespacePrefix(aProcess));
        out.write("=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getNamespaceURI(aProcess));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   xmlns:util=\"http://www.springframework.org/schema/util\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t<bean id=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tclass=\"org.springframework.beans.factory.config.PropertyPlaceholderConfigurer\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<property name=\"location\" value=\"classpath:");  //$NON-NLS-1$        
        out.write(SpagicUtils.getPropertyFileName(aProcess));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
 	   List<String> jndiDatasourcesNames = JBIJetUtils.getJndiDatasourceNames(stepsForSU);
	   for (String jndiDsName : jndiDatasourcesNames){

        out.write("\t\t\t<bean id=\"");  //$NON-NLS-1$        
        out.write(jndiDsName);
        out.write("\" class=\"org.springframework.jndi.JndiObjectFactoryBean\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<property name=\"jndiName\" value=\"java:comp/env/jdbc/");  //$NON-NLS-1$        
        out.write(jndiDsName);
        out.write("\"/> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</bean>\t\t");  //$NON-NLS-1$        
        out.write(NL);         

	   }

        out.write(NL);         
   
	   for (Step aStep: stepsForSU ){
	   		String templateName = JBIJetUtils.getJetTemplateForServiceBinding(JBIJetUtils.getRightStepBinding(aStep));
	   		context.setVariable("templateName", templateName);
	   		context.setVariable("step", aStep);
	   		

        RuntimeTagElement _jettag_c_include_68_4 = context.getTagFactory().createRuntimeTag(_jetns_c, "include", "c:include", _td_c_include_68_4); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_c_include_68_4.setRuntimeParent(null);
        _jettag_c_include_68_4.setTagInfo(_td_c_include_68_4);
        _jettag_c_include_68_4.doStart(context, out);
        _jettag_c_include_68_4.doEnd();
	 
	   }
	  
	   
	   if (JBIJetUtils.isRequiredNamespaceContext(su)){
	   		 Map<String, String> namespaceMap = JBIJetUtils.getNamespaceMap();

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write(":namespace-context id=\"nsContext\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t\t<");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write(":namespaces>");  //$NON-NLS-1$        
        out.write(NL);         
	
		for ( String prefixNs : namespaceMap.keySet()){

        out.write("\t\t\t<");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write(":namespace prefix=\"");  //$NON-NLS-1$        
        out.write(prefixNs);
        out.write("\">");  //$NON-NLS-1$        
        out.write(namespaceMap.get(prefixNs));
        out.write("</");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write(":namespace>\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
		
		}

        out.write("  \t\t\t</");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write(":namespaces>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(suNameSpacePrefix);
        out.write(":namespace-context>");  //$NON-NLS-1$        
        out.write(NL);         
	   } 

        out.write("</beans>");  //$NON-NLS-1$        
    }
}
