/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.jbi.smx.utils;

import java.util.Map;

import org.eclipse.stp.im.Step;


public class ConstructorArgPropertyMap extends SimplePropertyMap {
		
	public ConstructorArgPropertyMap(String imName, String runtimeName,
			boolean required) {
		super(imName, runtimeName, required);

	}

	/**
	 * @see org.spagic.im.out.jbi.smx.utils.IPropertyMap#eval(org.eclipse.stp.im.Step)
	 */
	public String eval(Step s){
		if (isUnderCondition() && !evaluateGenerationCondition(s)){
			return "";
		}
		String value = null;
		if (flagConst)
			value = constValue;
		else
			value = getPropertyValueFromStep(s);
		
		
		
		if (isRequired() && !JBIJetUtils.isValid(value)){
			throw new RuntimeException(" Property ["+imName+"] --> [] is required to generate code for Step ["+s.getName()+"] with Binding ["+JBIJetUtils.getRightStepBinding(s).getName()+"]");
		}
		if (!isRequired() && value == null){
			value = "";
		}
		if (!(produceConfiguration)){
			return "";
		}else{
			String finalValue =  decorator != null ? decorator.decorate(value) : value;
			if (isFlagRef())
				return "<constructor-arg ref=\""+finalValue+"\"/>\n";
			else
				return "<constructor-arg value=\""+finalValue+"\"/>\n";
		}
	
	}
	
	public String evalOnMap(Map<String, String> detailProperties){
		if (isUnderCondition() && !evaluateGenerationConditionOnMap(detailProperties)){
			return "";
		}
		
		String valueInIm = detailProperties.get(imName);		
		if (isRequired() && !JBIJetUtils.isValid(valueInIm)){
			throw new RuntimeException(" Property ["+imName+"] --> ["+runtimeName+"] is required to generate code for Step ");
		}
		if (!isRequired() && valueInIm == null){
			valueInIm = "";
		}
		if (!(produceConfiguration)){
			return "";
		}else{
			String finalValue =  decorator != null ? decorator.decorate(valueInIm) : valueInIm;
			if (isFlagRef())
				return "<constructor-arg ref=\""+finalValue+"\"/>\n";
			else
				return "<constructor-arg value=\""+finalValue+"\"/>\n";
		}
	
	}
	
	
	
	
	
	
	
}
